package bitel.billing.test.convert;

import java.io.UnsupportedEncodingException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.ResourceBundle;
import java.util.Set;
import java.util.Map.Entry;

import bitel.billing.common.CommonUtils;
import bitel.billing.common.IPUtils;
import bitel.billing.common.SimpleSetup;
import bitel.billing.common.TimeUtils;
import bitel.billing.server.Server;
import bitel.billing.server.ServerEventProcessor;
import bitel.billing.server.contract.bean.Contract;
import bitel.billing.server.contract.bean.ContractManager;
import bitel.billing.server.dialup.bean.DialUpLogin;
import bitel.billing.server.dialup.bean.DialUpLoginManager;
import bitel.billing.server.script.bean.event.EventProcessor;
import bitel.billing.server.util.DefaultServerSetup;
/*
 *   +
 *     4.4,     .
 */
public class NSPlus
{
    private static long GROUP_BITMASK = -1;
    private static int PATTERN_ID_JUR = -1; 
    private static int PATTERN_ID_PHIS = -1;    
    private static int FIO_PID = -1;
    private static int PHONE_PID = -1;
    private static int ADDRESS_JUR_PID_RAW = -1;
    private static int ADDRESS_PHIS_PID_RAW = -1;
    private static int DATE_PID = -1;    
    private static int EMAIL_PID_RAW = -1;
    private static int EMAIL_PID = -1;
    private static int TAX_NUMBER_PID = -1;
    private static int KPP_NUMBER_PID = -1;
    private static int PASSPORT_PID = -1;
    private static int ADDRESS_PID = -1;
    
    private static int ICQ_PID = -1;
    private static int ISJUR_PID_FLAG = -1;
    private static int COMMENT_PID = -1;
    private static int LOGIN_PID = -1;
    
    private static int DIALUP_MID = -1;    
    private static int USER_ID = -1;

    private static final Date currDate = new Date();

    /**      */
    private static final Calendar startMonth = new GregorianCalendar( 2008, Calendar.DECEMBER, 1 );
    
    /**   */
    private static Map<Integer, Integer> contractMap = new HashMap<Integer, Integer>();
    
    /**
     * @param args
     */
    public static void main( String[] args )
    {
        try
        {
            System.out.println( "start ("+args[0]+".properties)" );
            //
            ResourceBundle rb = ResourceBundle.getBundle( args[0] );
            SimpleSetup bundleSetup = new SimpleSetup();
            for( String key : rb.keySet() )
            {
                bundleSetup.setValue( key, rb.getString( key ) );
            }
            //  BG-
            DefaultServerSetup bgSetup = new DefaultServerSetup();
            for( Entry<String,String> param : bundleSetup.getHashValuesWithPrefix( "bg." ).entrySet() )
                bgSetup.setValue( param.getKey(), param.getValue() );
            //      
            GROUP_BITMASK = Long.parseLong( bgSetup.getStringValue( "GROUP_BITMASK" ), 16 );
            PATTERN_ID_JUR = Integer.parseInt( bgSetup.getStringValue( "PATTERN_ID_JUR" ) ); 
            PATTERN_ID_PHIS = Integer.parseInt( bgSetup.getStringValue( "PATTERN_ID_PHIS" ) ); 
            FIO_PID = Integer.parseInt( bgSetup.getStringValue( "FIO_PID" ) );
            PHONE_PID = Integer.parseInt( bgSetup.getStringValue( "PHONE_PID" ) );
            ADDRESS_JUR_PID_RAW = Integer.parseInt( bgSetup.getStringValue( "ADDRESS_JUR_PID_RAW" ) );
            ADDRESS_PHIS_PID_RAW = Integer.parseInt( bgSetup.getStringValue( "ADDRESS_PHIS_PID_RAW" ) );
            DATE_PID = Integer.parseInt( bgSetup.getStringValue( "DATE_PID" ) );    
            EMAIL_PID_RAW = Integer.parseInt( bgSetup.getStringValue( "EMAIL_PID_RAW" ) );
            EMAIL_PID = Integer.parseInt( bgSetup.getStringValue( "EMAIL_PID" ) );
            TAX_NUMBER_PID = Integer.parseInt( bgSetup.getStringValue( "TAX_NUMBER_PID" ) );
            KPP_NUMBER_PID = Integer.parseInt( bgSetup.getStringValue( "KPP_NUMBER_PID" ) );
            PASSPORT_PID = Integer.parseInt( bgSetup.getStringValue( "PASSPORT_PID" ) );
            ADDRESS_PID = Integer.parseInt( bgSetup.getStringValue( "ADDRESS_PID" ) );
            ICQ_PID = Integer.parseInt( bgSetup.getStringValue( "ICQ_PID" ) );
            ISJUR_PID_FLAG = Integer.parseInt( bgSetup.getStringValue( "ISJUR_PID_FLAG" ) );
            COMMENT_PID = Integer.parseInt( bgSetup.getStringValue( "COMMENT_PID" ) );
            LOGIN_PID = Integer.parseInt( bgSetup.getStringValue( "LOGIN_PID" ) );
            DIALUP_MID = Integer.parseInt( bgSetup.getStringValue( "DIALUP_MID" ) );
            USER_ID = Integer.parseInt( bgSetup.getStringValue( "USER_ID" ) );
            //  
            System.out.println( "init: setup, connection pool, event processor..." );
            //     ,     
            bgSetup.initConnectionPool();
            Server.initSetup();
            EventProcessor.initProcessor( bgSetup, true, new ServerEventProcessor() ); 
            System.out.println( "deleting contracts..." );
            ConvertUtil.removeContracts( GROUP_BITMASK, bgSetup );
            //System.exit( 0 );
            //
            int n = 0;
            while( rb.containsKey( "utm."+(++n)+".db.url" ) )
            {  
                //  UTM-
                DefaultServerSetup utmSetup = new DefaultServerSetup();
                for( Entry<String,String> param : bundleSetup.getHashValuesWithPrefix( "utm."+n+"." ).entrySet() )
                    utmSetup.setValue( param.getKey(), param.getValue() ); 
                //     / 1) bgCon  2) utmCon                
                convert( bgSetup, utmSetup );
            }            
        }
        catch ( Throwable e )
        {
            System.out.println( "ACHTUNG! exception '"+e+"'!" );
            e.printStackTrace();
        }
        finally
        {
            System.out.println( "the end, total time = " + ( System.currentTimeMillis() - currDate.getTime() )/1000 + " sec" );
            //System.out.println( "not_parsed = " + not_parsed );
            System.exit( 0 ); //
        }
    }

    private static void convert( DefaultServerSetup bgSetup, DefaultServerSetup utmSetup ) throws Exception
    {
        Connection utmCon = utmSetup.getDBConnection();
        //  BG- (    
        //  ,     )
        Connection bgCon = bgSetup.getDBConnection();
        ContractManager bgCM = new ContractManager( bgCon );
        DialUpLoginManager bgLoginManager = new DialUpLoginManager( bgCon, DIALUP_MID );//FIXME
        //
        System.out.println( "convert database " + utmCon.getCatalog() + "...");
        //
        System.out.print( "make utm user-service-links map...");
        Map<Integer, Set<LoginPassIpMask>> utmUserServiceLinksMap = getUtmServiceLinksMap( utmCon );
        System.out.println( "(size=" + utmUserServiceLinksMap.size() + ")" );
        //
        String utmEncode = utmSetup.getStringValue( "TEXT_ENCODE" );
        int NUM_CONTRACTS_CONVERT = utmSetup.getIntValue( "NUM_CONTRACTS_CONVERT", Integer.MAX_VALUE );
        /**  */
        int contractNum = 0;
        //
        String query = 
            "SELECT users.*, accounts.balance, accounts.credit " +
            "FROM users " +
            "LEFT JOIN accounts ON users.basic_account=accounts.id " +                
            "WHERE users.is_deleted=0 and accounts.unlimited=0";
        ResultSet rs = utmCon.createStatement().executeQuery( query );
        while( rs.next() )
        {                
            int utm_users_id = rs.getInt( "id" );
            String utm_users_login = readString( rs, "login", utmEncode );
            String utm_users_password = rs.getString( "password" );
            int utm_users_basic_account = rs.getInt( "basic_account" );
            boolean utm_users_is_juridical = rs.getBoolean( "is_juridical" );
            java.util.Date utm_users_create_date = new java.util.Date( 1000L * rs.getLong( "create_date" ) );
            String utm_users_work_telephone = rs.getString( "work_telephone" );
            String utm_users_home_telephone = rs.getString( "home_telephone" );
            String utm_users_mobile_telephone = rs.getString( "mobile_telephone" );
            String utm_users_juridical_address = readString( rs, "juridical_address", utmEncode );
            String utm_users_actual_address = readString( rs, "actual_address", utmEncode );
            String utm_users_email = rs.getString( "email" );
            String utm_users_full_name = readString( rs, "full_name", utmEncode );
            String utm_users_tax_number = readString( rs, "tax_number", utmEncode );
            String utm_users_kpp_number = readString( rs, "kpp_number", utmEncode );
            String utm_users_bank_account = readString( rs, "bank_account", utmEncode );
            String utm_users_passport = readString( rs, "passport", utmEncode );
            String utm_users_floor = readString( rs,  "floor", utmEncode );
            String utm_users_entered = readString( rs,  "entrance", utmEncode );
            String utm_users_flat_number = readString( rs,  "flat_number", utmEncode );
            String utm_users_comments = readString(rs, "comments", utmEncode );
            String utm_users_icq_number = readString(rs, "icq_number", utmEncode );
            int utm_users_is_blocked = rs.getInt( "is_blocked" );
            //
            System.out.println( "inserting login '" + utm_users_login + "' (users.id=" + utm_users_id + ", users.basic_account=" + utm_users_basic_account + ")..." );
            //
            Integer cid1 = contractMap.get( utm_users_basic_account );
            if ( cid1 != null )
            {
                System.out.println( "ACHTUNG! dublicate contract!" );
                System.exit( 1 );
            }
            contractMap.put( utm_users_basic_account, cid1 );
            //
            Contract contract = bgCM.createFromPattern( utm_users_is_juridical ? PATTERN_ID_JUR : PATTERN_ID_PHIS,
                                                      utmSetup.getStringValue("CONTRACT_NAME_PREFIX") + ConvertUtil.addNull( utm_users_basic_account, 8 ),
                                                      TimeUtils.convertDateToCalendar( utm_users_create_date ),
                                                      //startMonth,
                                                      utm_users_password );
            int cid = contract.getID();
            System.out.println( "    BG-contract: '" + contract.getTitle() + "'" );
            // , , 
            ConvertUtil.addContactGroup( cid, GROUP_BITMASK, bgCon );
            ConvertUtil.updateContactComment( cid, utm_users_full_name, bgCon );
            ConvertUtil.updateContactClosesumma( cid, rs.getDouble( "credit" ), bgCon );
            // 
            updateContactBalance( cid, rs, currDate, bgCon );
            //             
            int tpid = CommonUtils.parseIntString( utmSetup.getStringValue("TARIFFID"), -1 );
            if ( tpid>0 )
            {
                ConvertUtil.addTariff( cid, tpid, startMonth, bgCon );
            }
            //   - 
            ConvertUtil.addContactParamString( cid, bgCon, utm_users_full_name, FIO_PID );
            //   - 
            ConvertUtil.addContactParamString( cid, bgCon, combineTelehones( utm_users_work_telephone,
                                                                 utm_users_home_telephone,
                                                                 utm_users_mobile_telephone ),
                                               PHONE_PID );
            //   - 
            ConvertUtil.addContactParamDate( cid, bgCon, utm_users_create_date, DATE_PID );
            //   - 
            ConvertUtil.addContactParamString( cid, bgCon, utm_users_email, EMAIL_PID_RAW );
            ConvertUtil.addContactParamEmail( cid, bgCon, utm_users_email, EMAIL_PID );
            //   - 
            ConvertUtil.addContactParamString( cid, bgCon, utm_users_juridical_address, ADDRESS_JUR_PID_RAW );
            ConvertUtil.addContactParamString( cid, bgCon, combineAddress( utm_users_actual_address,
                                                                           utm_users_flat_number,
                                                                           utm_users_floor,
                                                                           utm_users_entered ), ADDRESS_PHIS_PID_RAW );
            // 
            // updateAddress( cid, rs, bgCon, utmEncode ); 
            //  
            ConvertUtil.addContactParamString( cid, bgCon, utm_users_tax_number, TAX_NUMBER_PID );
            ConvertUtil.addContactParamString( cid, bgCon, utm_users_kpp_number, KPP_NUMBER_PID );
            ConvertUtil.addContactParamString( cid, bgCon, utm_users_passport, PASSPORT_PID );
            ConvertUtil.addContactParamString( cid, bgCon, utm_users_icq_number, ICQ_PID );            
            ConvertUtil.addContactParamString( cid, bgCon, utm_users_login, LOGIN_PID );
            ConvertUtil.addContactParamFlag( cid, bgCon, utm_users_is_juridical, ISJUR_PID_FLAG );
            // 
            if( utm_users_comments!=null && utm_users_comments.length() > 100 )
            {
                ConvertUtil.updateComments( bgCon, cid, utm_users_comments );
            }
            else
            {
                ConvertUtil.addContactParamString( cid, bgCon, utm_users_comments, COMMENT_PID );
            }
            //  -
            ConvertUtil.setWebStatPassword( cid, bgCon, utm_users_password );
            //  
            Set<LoginPassIpMask> sls = utmUserServiceLinksMap.get( utm_users_id );
            //addDialupInfo( bgCon, cid, utm_users_is_blocked, utm_users_login, utm_users_password, sls, bgLoginManager, utmCon.getCatalog() );
            addDialupInfo( bgCon, cid, sls, bgLoginManager, utmCon.getCatalog() );
            //
            ++contractNum;
            if( contractNum >= NUM_CONTRACTS_CONVERT )
            {
            	System.out.println( "ACHTUNG! break convert! set limit: " + NUM_CONTRACTS_CONVERT );
            	break;
            }
        }
        //  UTM-  BG- 
        ConvertUtil.closeConnection( utmCon );
        ConvertUtil.closeConnection( bgCon );
    }

/*    
    //  58
    private static Pattern pattern1 = Pattern.compile( "^\\s*(\\S+)\\s*(\\d+)\\s*$" );
    //  58
    private static Pattern pattern2 = Pattern.compile( "^\\s*(\\S+)\\s*(\\d+)(\\S{1})\\s*$" );
    //  58 - 123
    private static Pattern pattern3 = Pattern.compile( "^\\s*(\\S+)\\s*(\\d+)(\\S{1})\\s*-\\s*(\\d+)\\s*$" );
    //  58-22
    private static Pattern pattern4 = Pattern.compile( "^\\s*(\\S+)\\s*(\\d+)\\s*-\\s*(\\d+)\\s*$" );
    //  58/,  58/1
    //private static Pattern pattern5 = Pattern.compile( "^\\s*(\\S+)\\s*(\\d+)/(\\S+)\\s*$" );
    
    static int not_parsed = 0;
    //564 632 155 151
    //356
    //TO DO 
    private static void updateAddress( int cid, ResultSet rs, Connection bgCon, String utmEncode ) throws UnsupportedEncodingException, SQLException
    {
        String utm_users_actual_address = readString( rs, "actual_address", utmEncode );
        if( CommonUtils.notBlankString( utm_users_actual_address ) )
        {
            String utm_users_floor = readString( rs,  "floor", utmEncode );
            String utm_users_entered = readString( rs,  "entrance", utmEncode );
            String utm_users_flat_number = readString( rs,  "flat_number", utmEncode );
            
            String street = null;
            String house = null;
            String frac = null;
            String flat = null;
            Matcher m = null;            
            if( (m = pattern1.matcher( utm_users_actual_address )).find() )
            {
                street = m.group( 1 );
                house = m.group( 2 );
                //System.out.print("address='"+utm_users_actual_address+"' : ");
                //System.out.println( "(1) street='"+street+"',house='"+house+"'" );
            }
            else if( (m = pattern2.matcher( utm_users_actual_address )).find() )
            {
                street = m.group( 1 );
                house = m.group( 2 );
                frac = m.group( 3 );
                //System.out.print("address='"+utm_users_actual_address+"' : ");
                //System.out.println( "(2) street='"+street+"',house='"+house+"',frac='"+frac+"'" );
            }
            else if( (m = pattern3.matcher( utm_users_actual_address )).find() )
            {
                street = m.group( 1 );
                house = m.group( 2 );
                frac = m.group( 3 );
                flat = m.group( 4 );
                //System.out.print("address='"+utm_users_actual_address+"' : ");
                //System.out.println( "(3) street='"+street+"',house='"+house+"',frac='"+frac+"',flat='"+flat+"'" );
            }
            else if( (m = pattern4.matcher( utm_users_actual_address )).find() )
            {
                street = m.group( 1 );
                house = m.group( 2 );
                flat = m.group( 3 );
                System.out.print("address='"+utm_users_actual_address+"' : ");
                System.out.println( "(4) street='"+street+"',house='"+house+"',flat='"+flat+"'" );
            }            
            else if( (m = pattern5.matcher( utm_users_actual_address )).find() )
            {
                street = m.group( 1 );
                house = m.group( 2 );
                frac = m.group( 3 );
                System.out.print("address='"+utm_users_actual_address+"' : ");
                System.out.println( "(5) street='"+street+"',house='"+house+"',frac='"+frac+"'" );
            }            
            else
            {
                System.out.println( "WARNING! Unknown address format: '"  + utm_users_actual_address + "'");      
                ++not_parsed;
                return;
            }
                
            //
            
            //String query =
            //    "INSERT INTO contract_parameter_type_2 (cid, pid, flat, pod, floor, address, hid) VALUES (?, ?, ?, ?, ?, ?, 0)";
            //PreparedStatement psInsertAddressParam = bgCon.prepareStatement( query );                
            //psInsertAddressParam.setInt( 1, cid );
            //psInsertAddressParam.setInt( 2, ADDRESS_PID );
            //psInsertAddressParam.setString( 3, utm_users_flat_number );
            //psInsertAddressParam.setInt( 4, CommonUtils.parseIntString( utm_users_entered ) );
            //psInsertAddressParam.setInt( 5, CommonUtils.parseIntString( utm_users_floor ) );
            //psInsertAddressParam.setString( 6, utm_users_actual_address );
            //psInsertAddressParam.executeUpdate();
        }
    }
*/

    /*
	private static Map<Integer, Set<Long>> getUtmUserIPMap( Connection utmCon ) throws SQLException
    {
        String query = "SELECT ip_groups.ip , service_links.user_id FROM ip_groups " + 
        " LEFT JOIN iptraffic_service_links ON ip_groups.ip_group_id = iptraffic_service_links.ip_group_id " +
        " LEFT JOIN service_links ON iptraffic_service_links.id = service_links.id " + 
        " WHERE ip_groups.is_deleted = 0 " +
        " AND service_links.is_deleted = 0";
        PreparedStatement ps = utmCon.prepareStatement( query );
        ResultSet rs = ps.executeQuery();
        Map<Integer, Set<Long>> userIP = new HashMap<Integer, Set<Long>> ();
        while (rs.next())
        {
            long  ip = rs.getLong( 1 );
            int  uid = rs.getInt( 2 );
            //            
            Set<Long> ips = userIP.get( uid );
            //
            if (ips == null)
            {
                ips = new HashSet<Long> (); 
                userIP.put( uid, ips );
            }
            ips.add( ip );
        }
        return userIP;
    }
    */
    
	/*
    private static void addDialupInfo( Connection bgCon,                                                                                                           
                                  int cid,
                                  int utm_users_is_blocked, String utm_users_login, String utm_users_password,
                                  Set<LoginPassIpMask> sls,
                                  DialUpLoginManager bgLoginManager,
                                  String currentUtmDbName ) throws Exception
    {
        DialUpLogin login = new DialUpLogin();
        login.setId( -1 );
        login.setCid( cid );
        login.setStatus( utm_users_is_blocked!=0 ); //TODO ?
        login.setMaxSession( -1 ); //TODO ?
        login.setDate1( ConvertUtil.convertCalendarToSqlDate( startMonth ) );
        login.setDate2( null );        
        login.setPswd( utm_users_password );
        login.setComment( "    "+currentUtmDbName ); 
        login.setObjectId( 0 ); //TODO ?
        //  => updateLogin( login,  new DialUpLoginManager( con, mid ) );        
        //
        Set<String> aliases = new HashSet<String>();
        aliases.add( utm_users_login );
        //
        String error = bgLoginManager.checkAliases( login, aliases );
        if( error != null )
        {
            //throw new Exception( error );
            System.out.println( "ACHTUNG! checkAliases not passed! alias='"+aliases.toArray()[0]+"' reason='"+error+"'" );
            return;
        }
        //
        if ( login.getId() <= 0 )
        {
            String checkResult = null;
            if( (checkResult = bgLoginManager.checkLoginAvailable( new DefaultServerSetup() )) != null )
            {
                //throw new Exception( checkResult );
                System.out.println( "ACHTUNG! checkLoginAvailable not passed! reason='"+checkResult+"'" );
                return;
            }
            login = bgLoginManager.addLogin( login, new DefaultServerSetup() );
        }
        else
        {
            error = bgLoginManager.checkLogin( login );
            if( error != null )
            {
                //throw new Exception( error );
                System.out.println( "ACHTUNG! checkLogin not passed! reason='"+error+"'" );
                return;
            }
            bgLoginManager.updateLogin( login );
        }
        //
        bgLoginManager.updateAliases( login.getId(), aliases );
        //
        bgLoginManager.updatePassword( login.getId(), login.getPswd(), -1 );
        //        
        //EventProcessor.getProcessor().addEvent( new LoginUpdateEvent( DIALUP_MID, login ) );
        
        //  IP
        
        //if(ips!=null && ips.size()>1)
        //{
        //    System.out.println( "ACHTUNG! more ip than 1 !" );
        //}
        
        if (ips != null)
        {
            String query = "INSERT INTO radius_pair_ip_" + DIALUP_MID + " (id, ip, realm) VALUES (?, ?, 'default')";
            PreparedStatement ps = bgCon.prepareStatement( query );            
            for (Long ip : ips )
            {
                ps.setInt( 1, login.getId() );
                ps.setLong( 2, ip );
                ps.executeUpdate();
            }
            ps.close();
        }
    }
	*/
    
	private static Map<Integer, Set<LoginPassIpMask>> getUtmServiceLinksMap( Connection utmCon ) throws SQLException
    {
        String query = "SELECT ip_groups.ip , service_links.user_id ,ip_groups.mask, ip_groups.uname, ip_groups.upass FROM ip_groups " + 
        " LEFT JOIN iptraffic_service_links ON ip_groups.ip_group_id = iptraffic_service_links.ip_group_id " +
        " LEFT JOIN service_links ON iptraffic_service_links.id = service_links.id " + 
        " WHERE ip_groups.is_deleted = 0 " +
        " AND service_links.is_deleted = 0";
        PreparedStatement ps = utmCon.prepareStatement( query );
        ResultSet rs = ps.executeQuery();
        Map<Integer, Set<LoginPassIpMask>> userSL = new HashMap<Integer, Set<LoginPassIpMask>> ();
        while ( rs.next() )
		{
			long ip = rs.getLong( 1 );
			int uid = rs.getInt( 2 );
			//
			long mask = rs.getLong( 3 );
			String uname = rs.getString( 4 );
			String upass = rs.getString( 5 );
			//    -         - 
			// ,      " vpn "
			if( CommonUtils.isBlankString( uname ) )
			{
				//System.err.println( "ACHTUNG! uname='"+uname+"', uid="+uid );
				continue;
			}			
			//
			if( ip<0 )
			{	
				//System.out.print( ip );
				ip+=0x100000000L;
				//System.out.print( " -> " + ip );
				//System.out.println( " -> " + IPUtils.convertIpToString( ip ) );
			}
			if( mask<0 )
			{
				//System.out.print( mask );
				mask+=0x100000000L;
				//System.out.print( " -> " + mask );
				//System.out.println( " -> " + IPUtils.convertIpToString( mask ) );
			}			
			//            
			Set<LoginPassIpMask> sls = userSL.get( uid );
			if ( sls == null )
			{
				sls = new HashSet<LoginPassIpMask>();
				userSL.put( uid, sls );
			}			
			sls.add( new LoginPassIpMask( uname, upass, ip, mask ) );
		}
        return userSL;
    }

    private static void addDialupInfo( Connection bgCon,                                                                                                           
                                  int cid,
                                  Set<LoginPassIpMask> sls,
                                  DialUpLoginManager bgLoginManager,
                                  String currentUtmDbName ) throws Exception
    {
    	if( sls != null )
    	{
	    	for( LoginPassIpMask lpim : sls )
	    	{
    		System.out.println( "    add dialup login '" + lpim.login + "' (ip/mask=" + IPUtils.convertIpToString( lpim.ip ) + "/" + IPUtils.convertIpToString( lpim.mask ) + ")..." );
    		DialUpLogin login = new DialUpLogin();
            login.setId( -1 );
            login.setCid( cid );
            login.setStatus( lpim.blocked==0 ); //TODO ?
            login.setMaxSession( -1 ); //TODO ?
            login.setDate1( ConvertUtil.convertCalendarToSqlDate( startMonth ) );
            login.setDate2( null );        
            login.setPswd( lpim.password );
            login.setComment( "    "+currentUtmDbName ); 
            login.setObjectId( 0 ); //TODO ?
            //  => updateLogin( login,  new DialUpLoginManager( con, mid ) );        
            //
            Set<String> aliases = new HashSet<String>();
            aliases.add( lpim.login );
            //
            String error = bgLoginManager.checkAliases( login, aliases );
            if( error != null )
            {
                //throw new Exception( error );
                System.out.println( "ACHTUNG! checkAliases not passed! alias='"+aliases.toArray()[0]+"' reason='"+error+"'" );
                continue;
            }
            //
            if ( login.getId() <= 0 )
            {
                String checkResult = null;
                if( (checkResult = bgLoginManager.checkLoginAvailable( new DefaultServerSetup() )) != null )
                {
                    //throw new Exception( checkResult );
                    System.out.println( "ACHTUNG! checkLoginAvailable not passed! reason='"+checkResult+"'" );
                    continue;
                }
                login = bgLoginManager.addLogin( login, new DefaultServerSetup() );
            }
            else
            {
            	System.out.println( "ACHTUNG! login.getId() > 0" );
            	System.exit( 1 );
//                error = bgLoginManager.checkLogin( login );
//                if( error != null )
//                {
//                    //throw new Exception( error );
//                    System.out.println( "ACHTUNG! checkLogin not passed! reason='"+error+"'" );
//                    continue;
//                }
//                bgLoginManager.updateLogin( login );
            }
            //
            bgLoginManager.updateAliases( login.getId(), aliases );
            //
            bgLoginManager.updatePassword( login.getId(), login.getPswd(), USER_ID );
            //        
            //EventProcessor.getProcessor().addEvent( new LoginUpdateEvent( DIALUP_MID, login ) );
            //  IP            
            if ( lpim.ip != null )
            {
            	long[] nv = IPUtils.netMaskToRange( lpim.ip.longValue(), lpim.mask.longValue() );
            	for( long ip=nv[0]; ip<=nv[1]; ip++ )
        		{
            		System.out.println( "        insert ip='" + IPUtils.convertIpToString( ip ) + "'" );
        			String query = "INSERT INTO radius_pair_ip_" + DIALUP_MID + " (id, ip, realm) VALUES (?, ?, 'default')";
        			PreparedStatement ps = bgCon.prepareStatement( query );            
        			ps.setInt( 1, login.getId() );
        			ps.setLong( 2, ip );
                	ps.executeUpdate();
                	ps.close();
        		}
            }
	    	} 
    	}
    	else
    	{
    		System.out.println( "    no dialup login" );
    	}
    }

    private static void updateContactBalance( int cid, ResultSet rs, Date currDate, Connection con )
        throws SQLException
    {
        Calendar cal = new GregorianCalendar();
        cal.setTime( currDate );
        int year = cal.get( Calendar.YEAR );
        int month = cal.get( Calendar.MONTH ) + 1;
        double balance = rs.getDouble( "balance" );
        //
        String query = "INSERT INTO contract_balance(yy, mm, cid, summa1, summa2, summa3, summa4) VALUES(?, ?, ?, ?, 0, 0, 0)";
        PreparedStatement ps = con.prepareStatement( query );
        ps.setInt( 1, year );
        ps.setInt( 2, month );
        ps.setInt( 3, cid );
        ps.setDouble( 4, balance );
        ps.executeUpdate();
        ps.close();
    }

    private static String combineTelehones( String workTelephone,
                                        String homeTelephone,
                                        String mobileTelephone )
    {
        StringBuilder telephones = new StringBuilder(128);
        boolean isfirst = true;
        if ( CommonUtils.notBlankString( workTelephone ) )
        {
            telephones.append( workTelephone ).append( "()" );
            isfirst = false;
        }
        if ( CommonUtils.notBlankString( homeTelephone ) )
        {
            if ( !isfirst )
            {
                telephones.append( ", " );
            }
            telephones.append( homeTelephone ).append( "()" );
            isfirst = false;            
        }
        if ( CommonUtils.notBlankString( mobileTelephone ) )
        {
            if ( !isfirst )
            {
                telephones.append( ", " );
            }
            telephones.append( mobileTelephone ).append( "()" );  
            isfirst = false;
        }
        return telephones.toString();
    }

    private static String combineAddress( String actualAddress,
                                          String flatNumber,
                                          String floor,
                                          String entered )
    {
        StringBuilder address = new StringBuilder(256);
        address.append( actualAddress );
        if ( CommonUtils.notBlankString( flatNumber ) )
        {
            address.append( ", . " ).append( flatNumber );
        }
        if ( CommonUtils.notBlankString( floor ) )
        {
            address.append( ",  " ).append( floor );
        }
        if ( CommonUtils.notBlankString( entered ) )
        {
            address.append( ",  " ).append( entered );
        }
        return address.toString();
    }

    private static String readString( ResultSet resultSet, String field, String encode ) throws UnsupportedEncodingException, SQLException
    {
        byte [] bytes = resultSet.getBytes( field );
        return bytes == null ? null : new String( bytes, encode );
    } 
}

class LoginPassIpMask
{
	public String login;
	public String password;
	public Long ip;
	public Long mask;
	public int blocked;
	
	public LoginPassIpMask( String login, String password, Long ip, Long mask )
	{
		super();
		this.login = login;
		this.password = password;
		this.ip = ip;
		this.mask = mask != null ? mask : 0xFFFFFFFFL;
	}
}


